SystemOrganization addCategory: #'IRDA2013-sorting2-Tests'!

TestCase subclass: #S2BubbleSortTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2BubbleSortTests methodsFor: 'as yet unclassified' stamp: 'db 5/13/2013 17:58:33.486'!
testStepwiseSorting
	| list sorter newList |
	"list to sort"
	list := #(3 2 4 1) asOrderedCollection.
	"initializing bubble sorter"
	sorter := S2BubbleSorter new.
	sorter model: list.
	
	self assert: sorter isSorted not.	
		
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 4 1) asOrderedCollection.
	self assert: sorter isSorted not.	
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 4 1) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 1 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 1 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 1 3 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 1 3 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(1 2 3 4) asOrderedCollection.
	self assert: sorter isSorted.
	
! !

TestCase subclass: #S2BubblesorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2BubblesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:39:56.246'!
testSort
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #(2 5 8 2 6 4 8 2).
	sortedList := #(2 2 2 4 5 6 8 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2BubblesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:40:49.605'!
testSortAllEqual
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #(2 2 2) asOrderedCollection.
	sortedList := #(2 2 2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2BubblesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:41:06.671'!
testSortEmpty
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #() asOrderedCollection.
	sortedList := #() asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2BubblesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:41:27.804'!
testSortOne
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #(2) asOrderedCollection.
	sortedList := #(2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

TestCase subclass: #S2ListTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:57:59.3'!
testAddElementAsSorted
	| expected list |
	list := S2List new.
	list sortedIndices: #(3 2) asSortedCollection.
	expected := #(4 3 2) asSortedCollection.
	list addIndexAsSorted: 4.
	self assert: (list sortedIndices) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:30:22.982'!
testInsertPivotAt1
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 7.
	expected := #(3 7 1 2 0 8 0 2) asOrderedCollection.
	list insertPivotAt: 3.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:21:25.101'!
testInsertPivotAt2
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 8.
	expected := #(2 3 7 2 0 8 0 1) asOrderedCollection.
	list insertPivotAt: 1.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:28:50.913'!
testInsertPivotAt3
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 4.
	expected := #(3 7 2 8 0 0 1 2) asOrderedCollection.
	list insertPivotAt: 7.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 19:25:35.429'!
testInsertPivotAt4
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 4.
	expected := #(3 7 2 0 8 0 1 2) asOrderedCollection.
	list insertPivotAt: 4.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:52:43.334'!
testSwitchElments
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	expected := #(3 7 8 0 2 0 1 2) asOrderedCollection.
	list switchElementAt: 3 withElementAt: 5.
	self assert: (list elements) equals: expected.! !

TestCase subclass: #S2QuicksortFocusedIndicesEvaluatorTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksortFocusedIndicesEvaluatorTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:44:31.421'!
testCompareElements1
|evaluator list|
	list := S2List new.
	list setupList: #(3 1 2).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	evaluator := S2QuicksortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator compareFocusedElements.
	! !

!S2QuicksortFocusedIndicesEvaluatorTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:45:56.2'!
testCompareElements2
|evaluator list|
	list := S2List new.
	list setupList: #(1 2 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	evaluator := S2QuicksortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator compareFocusedElements not.
	! !

!S2QuicksortFocusedIndicesEvaluatorTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:46:23.16'!
testCompareElements3
|evaluator list|
	list := S2List new.
	list setupList: #(4 5 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	evaluator := S2QuicksortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator compareFocusedElements not.
	! !

TestCase subclass: #S2QuicksortFocusedIndicesFinderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksortFocusedIndicesFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:48:39.782'!
testInitializeFocusedIndices
|finder list|
	list := S2List new.
	list setupList: #(3 1 6 4 7 2) asOrderedCollection.
	list leftBoundIndex: 1.
	list rightBoundIndex: 6.
	finder := S2QuicksortFocusedIndicesFinder newWithList: list.	
	finder initializeFocusedIndices.
	self assert: list firstFocusedIndex equals: 1.
	self assert: list secondFocusedIndex equals: 5.
	self assert: list pivotIndex equals: 6.! !

!S2QuicksortFocusedIndicesFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:51:21.49'!
testNextFocus1
| finder list |
	list := S2List new.
	list setupList: #(2 5 0 3 4 1 6 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 7.
	list pivotIndex: 8.
	finder := S2QuicksortFocusedIndicesFinder newWithList: list.
	finder nextFocusedElementsIndices.
	self assert: (list firstFocusedIndex) equals: 2.
	self assert: (list secondFocusedIndex) equals: 7.
	self assert: (list pivotIndex) equals: 8.
	! !

!S2QuicksortFocusedIndicesFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:51:31.374'!
testNextFocus2
| finder list |
	list := S2List new.
	list setupList: #(2 5 0 3 4 1 6 3).
	list firstFocusedIndex: 2.
	list secondFocusedIndex: 7.
	list pivotIndex: 8.
	finder := S2QuicksortFocusedIndicesFinder newWithList: list.
	finder nextFocusedElementsIndices.
	self assert: (list firstFocusedIndex) equals: 2.
	self assert: (list secondFocusedIndex) equals: 6.
	self assert: (list pivotIndex) equals: 8.
	! !

TestCase subclass: #S2QuicksortListPartFinderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:30:28.218'!
testFindLeftIndex1
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3) asOrderedCollection.
	list sortedIndices: #(3) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: 1.! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:31:06.935'!
testFindLeftIndex2
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asOrderedCollection.
	list sortedIndices: #(1 2 3 4 5) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: nil.! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:31:35.045'!
testFindLeftIndex3
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asOrderedCollection.
	list sortedIndices: #(2 3 4 5) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: 1.! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:32:08.959'!
testFindLeftIndex4
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asOrderedCollection.
	list sortedIndices: #(1 2 4 5) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: 3.! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:35:54.161'!
testFindRightIndex1
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asSortedCollection.
	list sortedIndices: #(3) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findRightIndex) equals: 2! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:36:21.368'!
testFindRightIndex2
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asSortedCollection.
	list sortedIndices: #(1 2 3 4 5) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findRightIndex) equals: nil! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:36:54.828'!
testFindRightIndex3
|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asSortedCollection.
	list sortedIndices: #(1 2 3 4) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findRightIndex) equals: 5! !

TestCase subclass: #S2QuicksortListPartSorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksortListPartSorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:42:11.458'!
testUpdatePivotPosition
	| list partSorter |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 3.
	list pivotIndex: 5.
	partSorter := S2QuicksortListPartSorter newWithList: list.
	partSorter updatePivotPosition.
	self assert: (list elements) equals: #(2 8 2 4 6) asOrderedCollection.! !

TestCase subclass: #S2QuicksorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:53:03.894'!
testSort
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #(2 5 8 2 6 4 8 2).
	sortedList := #(2 2 2 4 5 6 8 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2QuicksorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:42:37.514'!
testSortAllEqual
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #(2 2 2 2).
	sortedList := #(2 2 2 2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2QuicksorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:42:06.339'!
testSortEmpty
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #().
	sortedList := #() asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2QuicksorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:42:18.016'!
testSortOne
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #(2).
	sortedList := #(2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !
